package cokr.xit.fims.epst.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CmmnUtil;
import cokr.xit.fims.epst.EpostQuery;
import cokr.xit.fims.epst.EpostRcptRslt;
import cokr.xit.fims.epst.dao.EpostRcptRsltMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**전자우편 접수 결과 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-12-12	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("epostRcptRsltBean")
public class EpostRcptRsltBean extends AbstractBean {

	/** 전자우편 접수 결과 정보 DAO */
	@Resource(name = "epostRcptRsltMapper")
	private EpostRcptRsltMapper epostRcptRsltMapper;

	/**지정한 조건에 따라 전자우편 접수 결과 목록을 조회하여 반환한다.
	 * @param req 전자우편 접수 결과 조회 조건
	 * @return 전자우편 접수 결과 목록
	 */
	public List<DataObject> getEpostRcptRsltList(EpostQuery req) {
		// 사용 여부 확인
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			if (req.getBy() == null) {
				req.setOrderBy("REG_DT");
			} else {
				req.setOrderBy(CmmnUtil.convertCamelCaseToSnakeCase(req.getBy()));
			}
		}

		return epostRcptRsltMapper.selectEpostRcptRsltList(req);
	}

	/**지정한 조건에 따라 전자우편 접수 결과 객체들을 반환한다.
	 * @param req 전자우편 접수 결과 조회 조건
	 * @return 전자우편 접수 결과 객체 목록
	 */
	public List<DataObject> getEpostRcptRslts(EpostQuery req) {
		return epostRcptRsltMapper.selectEpostRcptRslts(req);
	}

	/**지정한 조건에 따라 전자우편 접수 결과의 합계 건수, 금액을 반환한다.
	 * @param req 전자우편 접수 결과 조회 조건
	 * @return 전자우편 접수 결과의 합계 건수, 금액
	 */
	public List<DataObject> getEpostRcptRsltSum(EpostQuery req) {
		return epostRcptRsltMapper.selectEpostRcptRsltSum(req);
	}

	/**전자우편 접수 결과 정보를 등록한다.
	 * @param epostRcptRslt 전자우편 접수 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(EpostRcptRslt epostRcptRslt) {
		return epostRcptRsltMapper.insert(epostRcptRslt);
	}

	/**전자우편 접수 결과 정보를 수정한다.
	 * @param epostRcptRslt 전자우편 접수 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean update(EpostRcptRslt epostRcptRslt) {
		return epostRcptRsltMapper.update(epostRcptRslt);
	}

	/**전자우편 접수 결과 정보를 삭제한다.
	 * @param epostRcptRslt 전자우편 접수 결과
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean remove(EpostRcptRslt epostRcptRslt) {
		return epostRcptRsltMapper.delete(epostRcptRslt);
	}

}
